//+------------------------------------------------------------------+
//|                                                  ReinitClass.mqh |
//|                             Copyright (c) 2009, Vladimir Gomonov |
//|                                            MetaDriver@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "(c) 2009, Vladimir Gomonov"
#property link      "MetaDriver@rambler.ru"

class cChartReInit
{
private:
  string    pButtonName;
  string    pText;
  color     pTextColor;
  color     pBackColor;
  void      CreateReinitButton(long wh);
public:
            cChartReInit() {}
            ~cChartReInit() { Deinit(); }
  void      Init(string, string, color,color);
  void      Deinit();
  void      Run();
};

void cChartReInit::Init(string BName,string Text,color TextColor,color BackColor)
  {
   pButtonName=BName;
   pText=Text;
   pTextColor=TextColor;
   pBackColor=BackColor;
   EventSetMillisecondTimer(50);
  }

void cChartReInit::Deinit() 
  {
   EventKillTimer();
   for(long i=ChartNext(0);i>0;i=ChartNext(i)) ObjectDelete(i,pButtonName);
  }      
  
void cChartReInit::Run() // Scanning all charts and reinit if button is pushed
  {
   for(long i=ChartNext(0);i>0;i=ChartNext(i))
    {
     if(!ChartGetInteger(i,CHART_WINDOW_IS_VISIBLE)) continue;
     long wc = ChartGetInteger(i,CHART_WINDOWS_TOTAL);
     long wi = ObjectFind(i, pButtonName);
     if(--wc!=wi) { CreateReinitButton(i); ChartRedraw(i); continue;}
     if(ObjectGetInteger(i,pButtonName,OBJPROP_STATE))
       {
        ObjectSetInteger(i,pButtonName,OBJPROP_STATE,false);
        MqlRates R[1];
         CopyRates(ChartSymbol(i),ChartPeriod(i),50000000,1,R);
 //       ENUM_TIMEFRAMES cp = ChartPeriod(i);
 //
 //       ChartSetSymbolPeriod(i, ChartSymbol(i), ((cp==PERIOD_M1) ? PERIOD_M5 : PERIOD_M1));
 //       Sleep(1200);
 //       ChartSetSymbolPeriod(i, ChartSymbol(i), cp);
       }
     ChartRedraw(i);
    } // for(Charts)
  }
  
void cChartReInit::CreateReinitButton(long wh)
  {
   ObjectDelete(wh,pButtonName); // delete if exist, but not relevant subwindow 
   int wc = (int)ChartGetInteger(wh,CHART_WINDOWS_TOTAL);
   // Creation and design button
   ObjectCreate(wh,pButtonName,OBJ_BUTTON,--wc,0,0);
   ObjectSetInteger(wh,pButtonName,OBJPROP_CORNER,CORNER_RIGHT_LOWER);
   ObjectSetInteger(wh,pButtonName,OBJPROP_ANCHOR,ANCHOR_RIGHT);
   ObjectSetInteger(wh,pButtonName,OBJPROP_XDISTANCE,75);
   ObjectSetInteger(wh,pButtonName,OBJPROP_YDISTANCE,15);
   ObjectSetInteger(wh,pButtonName,OBJPROP_XSIZE,74);
   ObjectSetInteger(wh,pButtonName,OBJPROP_YSIZE,14);
   ObjectSetInteger(wh,pButtonName,OBJPROP_COLOR,pTextColor);
   ObjectSetInteger(wh,pButtonName,OBJPROP_BGCOLOR,pBackColor);
   ObjectSetInteger(wh,pButtonName,OBJPROP_SELECTABLE,false);
//   ObjectSetInteger(wh,FR,OBJPROP_BACK,true);
   ObjectSetString(wh,pButtonName,OBJPROP_TEXT,pText);
   ObjectSetString(wh,pButtonName,OBJPROP_FONT,"Verdana");//"Calibri");
   ObjectSetInteger(wh,pButtonName,OBJPROP_FONTSIZE,6);
   ObjectSetDouble(wh,pButtonName,OBJPROP_ANGLE,90);
  }
